#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> G;
vector<int> us;
set<int> ans;

void dfs(int v, int m) {
    if (m > 0) {
        ans.insert(v);
        us[v] = 1;
        for (int j: G[v]) {
            if (us[j] == 0) {
                m--;
                ans.insert(j);
                dfs(j, m);
            }
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    G.resize(n);
    us.resize(n);
    for (int i: us) {
        i = 0;
    }
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        G[x - 1].push_back(y - 1);
        G[y - 1].push_back(x - 1);
    }
    vector<pair<int, int>> sc(k);
    for (int i = 0; i < k; ++i) {
        cin >> sc[i].first >> sc[i].second;
        sc[i].first--;
    }
    for (int i = 0; i < k; ++i) {
        ans.insert(sc[i].first);
        for (int j = 0; j < G[sc[i].first].size(); ++j) {
            dfs(sc[i].first, sc[i].second);
        }
    }
    cout << ans.size() << endl;
    if (ans.size() == 0) {
        cout << " ";
    }
    for (int i: ans) {
        cout << i + 1 << " ";
    }
}
